<p align="center"><a href="https://neard.io" target="_blank"><img width="100" src="https://neard.io/img/logo.png"></a></p>

<p align="center">
  <a href="https://neard.io/release/latest"><img src="https://img.shields.io/github/release/neard/neard.svg?style=flat-square" alt="GitHub release"></a>
  <a href="https://neard.io/releases"><img src="https://img.shields.io/github/downloads/neard/neard/total.svg?style=flat-square" alt="Total downloads"></a>
  <a href="https://travis-ci.com/neard/neard"><img src="https://img.shields.io/travis/com/neard/neard/master.svg?style=flat-square" alt="Build Status"></a>
  <a href="https://app.codacy.com/gh/neard/neard"><img src="https://img.shields.io/codacy/grade/75278913a45643ab871b87283963b3c5.svg?style=flat-square" alt="Code Quality"></a>
  <br /><a href="https://github.com/sponsors/crazy-max"><img src="https://img.shields.io/badge/sponsor-crazy--max-181717.svg?logo=github&style=flat-square" alt="Become a sponsor"></a>
  <a href="https://www.paypal.me/crazyws"><img src="https://img.shields.io/badge/donate-paypal-00457c.svg?logo=paypal&style=flat-square" alt="Donate Paypal"></a>
</p>

## About

**Neard** is a portable WAMP software stack involving useful binaries, tools and applications for your web development.

![](https://neard.io/img/screenshots/menu1.png)  ![](https://neard.io/img/screenshots/menu2.png)  ![](https://neard.io/img/screenshots/menu-tools2.png)

It also offers several versions of the various [modules](https://neard.io/modules) for download on the [official website](https://neard.io) and many other features.<br />
For those who wish to contribute, have an issue or questions, read the [Documentation](https://neard.io/doc).

### Modules

* ![](https://neard.io/img/modules/type-app.png) [Adminer](https://neard.io/modules/adminer) : a full-featured database management tool written in PHP.
* ![](https://neard.io/img/modules/type-bin.png) [Apache](https://neard.io/modules/apache) : the world's most used web server software.
* ![](https://neard.io/img/modules/type-tool.png) [Composer](https://neard.io/modules/composer) : a dependency manager for PHP.
* ![](https://neard.io/img/modules/type-tool.png) [ConsoleZ](https://neard.io/modules/consolez) : modified version of Console 2 for a better experience.
* ![](https://neard.io/img/modules/type-bin.png) [Filezilla](https://neard.io/modules/filezilla) : a FTP server application.
* ![](https://neard.io/img/modules/type-tool.png) [Ghostscript](https://neard.io/modules/ghostscript) : an interpreter for the PostScript language and for PDF.
* ![](https://neard.io/img/modules/type-tool.png) [Git](https://neard.io/modules/git) : a widely used version control system for software development.
* ![](https://neard.io/img/modules/type-app.png) [GitList](https://neard.io/modules/gitlist) : an elegant and modern git repository viewer.
* ![](https://neard.io/img/modules/type-bin.png) [MailHog](https://neard.io/modules/mailhog) : a Web and API based SMTP testing.
* ![](https://neard.io/img/modules/type-bin.png) [MariaDB](https://neard.io/modules/mariadb) : a community-developed fork of the MySQL relational database management system.
* ![](https://neard.io/img/modules/type-bin.png) [MongoDB](https://neard.io/modules/mongodb) : a free and open-source cross-platform document-oriented database program.
* ![](https://neard.io/img/modules/type-bin.png) [Memcached](https://neard.io/modules/memcached) : a distributed memory object caching system.
* ![](https://neard.io/img/modules/type-bin.png) [MySQL](https://neard.io/modules/mysql) : an open-source relational database management system.
* ![](https://neard.io/img/modules/type-tool.png) [ngrok](https://neard.io/modules/ngrok) : secure tunnels to localhost.
* ![](https://neard.io/img/modules/type-bin.png) [Node.js](https://neard.io/modules/nodejs) : an open-source, cross-platform runtime environment for developing server-side web applications.
* ![](https://neard.io/img/modules/type-tool.png) [Perl](https://neard.io/modules/perl) : a family of high-level, general-purpose, interpreted, dynamic programming languages.
* ![](https://neard.io/img/modules/type-bin.png) [PHP](https://neard.io/modules/php) : a server-side scripting language designed for web development including PEAR and extra extensions.
* ![](https://neard.io/img/modules/type-app.png) [phpMemAdmin](https://neard.io/modules/phpmemadmin) : to handle the administration of Memcached over the web.
* ![](https://neard.io/img/modules/type-app.png) [phpMyAdmin](https://neard.io/modules/phpmyadmin) : to handle the administration of MySQL and MariaDB over the Web.
* ![](https://neard.io/img/modules/type-app.png) [phpPgAdmin](https://neard.io/modules/phppgadmin) : a web-based administration tool for PostgreSQL.
* ![](https://neard.io/img/modules/type-bin.png) [PostgreSQL](https://neard.io/modules/postgresql) : an object-relational database management system (ORDBMS).
* ![](https://neard.io/img/modules/type-tool.png) [Python](https://neard.io/modules/python) : a widely used high-level, general-purpose, interpreted, dynamic programming language.
* ![](https://neard.io/img/modules/type-tool.png) [Ruby](https://neard.io/modules/ruby) : a dynamic, reflective, object-oriented, general-purpose programming language.
* ![](https://neard.io/img/modules/type-bin.png) [SVN](https://neard.io/modules/svn) : a software versioning and revision control system.
* ![](https://neard.io/img/modules/type-app.png) [Webgrind](https://neard.io/modules/webgrind) : the Xdebug Profiling Web Frontend in PHP.
* ![](https://neard.io/img/modules/type-app.png) [WebSVN](https://neard.io/modules/websvn) : an Online subversion repository browser.
* ![](https://neard.io/img/modules/type-tool.png) [XDebugClient](https://neard.io/modules/xdc) : a simple frontend for XDebug.
* ![](https://neard.io/img/modules/type-tool.png) [Yarn](https://neard.io/modules/yarn) : a fast, reliable, and secure dependency management.

## Documentation

* [Get started](https://neard.io/doc/get-started)
* [Screenshots](https://neard.io/doc/screenshots)
* [FAQ](https://neard.io/doc/faq)
* [Changelog](https://neard.io/doc/changelog)
* [Upgrade notes](https://neard.io/doc/upgrade-notes)
* [Reporting an issue](https://neard.io/doc/reporting-issue)
* [Request a module](https://neard.io/doc/request-module)
* [Contribute](https://neard.io/doc/contribute)
* [Translations](https://neard.io/doc/translations)

## How can I help ?

All kinds of contributions are welcome :raised_hands:! The most basic way to show your support is to star :star2: the project, or to raise issues :speech_balloon: You can also support this project by [**becoming a sponsor on GitHub**](https://github.com/sponsors/crazy-max) :clap: or by making a [Paypal donation](https://www.paypal.me/crazyws) to ensure this journey continues indefinitely! :rocket:

Thanks again for your support, it is much appreciated! :pray:

## License

LGPL-3.0. See `LICENSE` for more details.<br />
Icon credit to [David Vignoni](http://www.icon-king.com/).
